      
      PROGRAM FEAST_TEST
      IMPLICIT NONE
      
      INTEGER I
      INTEGER ITEC0
      integer matA_tnz, matB_tnz
      integer, allocatable :: matA_RIDX(:),matB_RIDX(:)
      integer, allocatable :: matA_CIDX(:),matB_CIDX(:)
      double complex, allocatable :: matA_comp(:),matB_comp(:)
      integer n
      INTEGER TEST
      double precision tp1,tp2
C     ==============================
c     mkl extended eigensolver(feast)
      CHARACTER*1 uplo    ! 'U' or 'L' or 'F'
      integer fpm(128) ! various parameters
      DOUBLE PRECISION emin, emax ! lower and upper bounds of the interval to be searched for eigvalues(emin<=emax)
      integer m0  ! initial guess for subspace dimension to be used (m0>=m; m: total # of eigvals in [emin,emax])
      DOUBLE PRECISION, ALLOCATABLE :: eval(:)   ! first m entries are eigvals found in the interval
      DOUBLE COMPLEX, ALLOCATABLE :: x(:,:) ! first m cols contain the orthonormal eigvecs corresponding to the e eigvals. 
                                              ! i-th col of x : eigvec associated with e(i)
      integer m   ! total # of eigvals found in the interval [emin,emax]
      double precision, allocatable :: res(:) ! first m components ocntain the relative residual vector
      
      double precision epsout
      integer loop    
      integer info
C     ==============================    

      ITEC0 = 1
      
c      OPEN(UNIT=ITEC0,file='read_mat_info_1.txt',status='OLD')
      OPEN(UNIT=ITEC0,file='read_mat_info_2.txt',status='OLD')
      
      READ(ITEC0,*)
      READ(ITEC0,*)
      READ(ITEC0,*) n
      READ(ITEC0,*)
      READ(ITEC0,*) matA_tnz
      READ(ITEC0,*)
      READ(ITEC0,*) matB_tnz
      allocate(matA_ridx(n+1),matB_ridx(n+1))
      allocate(matA_comp(matA_tnz),matB_comp(matB_tnz))
      allocate(matA_cidx(matA_tnz),matB_cidx(matB_tnz))
      
C     (1) Read matA info
      READ(ITEC0,*)
      READ(ITEC0,*)
      DO I = 1,matA_tnz
          READ(ITEC0,*) matA_cidx(I),tp1,tp2
          matA_comp(I) = DCMPLX(tp1,tp2)
      END DO
      READ(ITEC0,*)
      DO I = 1,n+1
          READ(ITEC0,*) matA_ridx(I)
      END DO
      
C     (2) Read matB info
      READ(ITEC0,*)    
      READ(ITEC0,*)
      DO I = 1,matB_tnz
          READ(ITEC0,*) matB_cidx(I),tp1,tp2
          matB_comp(I) = DCMPLX(tp1,tp2)
      END DO
      READ(ITEC0,*)
      DO I = 1,n
          READ(ITEC0,*) matB_ridx(I)
      END DO
      matB_ridx(n+1) = matB_tnz + 1        
      
c     (3) Solve generalized eigenvalue problem (Ax=lambda*B*x)
      
      m0 = n !undul_square:300 ! m0 should be less than or equal to ndof
      allocate(x(n,m0))    !allocate(x(blc_ndof,m0))   
      allocate(eval(m0))
      allocate(res(m0))
      x = 0.d0
      eval = 0.d0
      res = 0.d0      
      
      uplo = 'F'
      emin = -1.d10  
      emax = 1.d11

      CALL feastinit(fpm) ! initialize input parameters with default values
      fpm(1) = 1      
      
c       do i = 1,100
c     execution#1       
       CALL zfeast_hcsrgv(uplo,n,matA_comp,matA_ridx
     1 ,matA_cidx,matB_comp,matB_ridx,matB_cidx,fpm
     1 ,epsout,loop,emin,emax,m0,eval,x,m,res,info) 
      
      
         
       END